function $(id)
{
	return document.getElementById(id);
}


function Request(array)
{
	var xmlHttp = false;

	if (window.XMLHttpRequest)
	{
		xmlHttp = new XMLHttpRequest();
	}
	else if (window.ActiveXObject)
	{
		xmlHttp = new ActiveXObject('Microsoft.XMLHTTP');
	}

	if (!xmlHttp)
	{
		return false;
	}

	xmlHttp.open(array.method, array.file);
	xmlHttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=utf-8');
	xmlHttp.onreadystatechange = function()
	{
		if (xmlHttp.readyState == 4 && array.onComplete)
		{
			array.onComplete(xmlHttp.responseText);
		}
	};
	xmlHttp.send(array.params || null);
}

var Feed = {};
Feed.More = function(limit)
{
	new Request({
		file:	'includes/feed_ajax.php',
		method:	'post',
		params:	'limit=' + limit,
		onComplete: function(value)
		{
			$('feed').innerHTML = value;
		}
	});

	return false;
};

function Mark(token)
{
	var value = (token) ? 'checked' : '';

	for (var o = document.getElementsByTagName('input'), i = 0; i < o.length; i++)
	{
		if (o[i].type == 'checkbox')
		{
			o[i].checked = value;
		}
	}

	return false;
}

function Smilie(value)
{
	document.eintrag.text.value += value;
	document.eintrag.text.focus();

	return false;
}

function BBCode(aTag, eTag)
{
	var input = document.eintrag.text;
	input.focus();

	if (typeof document.selection != 'undefined')
	{
		var range = document.selection.createRange();
		var insText = range.text;
		range.text = aTag + insText + eTag;

		range = document.selection.createRange();

		if (insText.length == 0)
		{
			range.move('character', -eTag.length);
		}
		else
		{
			range.moveStart('character', aTag.length + insText.length + eTag.length);
		}

		range.select();
	}
	else if (typeof input.selectionStart != 'undefined')
	{
		var start = input.selectionStart;
		var end = input.selectionEnd;
		var insText = input.value.substring(start, end);
		input.value = input.value.substr(0, start) + aTag + insText + eTag + input.value.substr(end);

		var pos = start + aTag.length + (insText.length == 0 ? start + aTag.length + insText.length + eTag.length : '');
		input.selectionStart = pos;
		input.selectionEnd = pos;
	}
	else
	{
		var pos;
		var re = new RegExp('^[0-9]{0,3}$');

		while (!re.test(pos))
		{
			pos = prompt('Einf&uuml;gen an Position (0..' + input.value.length + '):', '0');
		}

		if (pos > input.value.length)
		{
			pos = input.value.length;
		}

		var insText = prompt('Bitte gib den zu formatierenden Text ein:');
		input.value = input.value.substr(0, pos) + aTag + insText + eTag + input.value.substr(pos);
	}
}

function Spoiler(div)
{
	var obj = div.parentNode.parentNode.getElementsByTagName('div')[1];

	if (obj.style.display == 'none')
	{
		obj.style.display = '';
		div.innerHTML = '<b>Spoiler: </b><a href=\'#\' onclick=\'return false;\'><b>Ausblenden</b></a>';
	}
	else
	{
		obj.style.display = 'none';
		div.innerHTML = '<b>Spoiler: </b><a href=\'#\' onclick=\'return false;\'><b>Anzeigen</b></a>';
	}
}