<?php
/**
*
* @package Itschi
* @since 2007/05/25
*
*/

error_reporting(E_ALL ^ E_NOTICE ^ E_DEPRECATED);

if (@ini_get('register_globals') == 1 || strtolower(@ini_get('register_globals')) == 'on')
{
	if (isset($_REQUEST['GLOBALS']))
	{
		exit;
	}

	$superglobals = array('_GET', '_POST', '_REQUEST', '_ENV', '_FILES', '_SESSION', '_COOKIES', '_SERVER');

	foreach ($superglobals as $value)
	{
		if (is_array($GLOBALS[$value]))
		{
			foreach ($GLOBALS[$value] as $key => $var)
			{
				if (isset($GLOBALS[$key]) && $var === $GLOBALS[$key])
				{
					unset($GLOBALS[$key]);
				}
			}
		}
	}
}

header('Content-Type: text/html; charset=utf-8');

$root = dirname(__FILE__) . '/';

require "{$root}config.php";
require "{$root}includes/user.php";
require "{$root}includes/mysql.php";
require "{$root}includes/cache.php";
require "{$root}includes/template.php";
require "{$root}includes/functions.php";
require "{$root}includes/constants.php";

if (empty($prefix))
{
	header('Location: install.php');
	exit;
}

$db = new mysql($hostname, $username, $password, $database);
$user = new user();
$cache = new cache();
$tpl = new template();
$config = config_vars();

unset($password);


$admin_tpl = ($user->row['user_level'] == ADMIN && (substr(dirname($_SERVER['PHP_SELF']), -5) == 'admin'));

$tpl->dir = ($admin_tpl) ? 'admin/template/' : 'styles/' . $config['theme'] . '/';


if ($config['enable'] && $user->row['user_level'] != ADMIN && basename($_SERVER['PHP_SELF']) != 'login.php')
{
	$message = ($config['enable_text']) ? $config['enable_text'] : 'Das Forum wurde deaktiviert';

	message_box($message, '', '');
}

?>